searchNodes=[{"doc":"Worker pool main interface. Use functions provided by this module to manage your pools of workers","ref":"wpool.html","title":"wpool","type":"module"},{"doc":"Casts a message to all the workers within the given pool.","ref":"wpool.html#broadcast/2","title":"wpool.broadcast/2","type":"function"},{"doc":"Equivalent to call(Sup, Call, default_strategy()) .","ref":"wpool.html#call/2","title":"wpool.call/2","type":"function"},{"doc":"Equivalent to call(Sup, Call, Strategy, 5000) .","ref":"wpool.html#call/3","title":"wpool.call/3","type":"function"},{"doc":"Picks a server and issues the call to it. For all strategies except available_worker, Timeout applies only to the time spent on the actual call to the worker, because time spent finding the worker in other strategies is negligible. For available_worker the time used choosing a worker is also considered","ref":"wpool.html#call/4","title":"wpool.call/4","type":"function"},{"doc":"Equivalent to cast(Sup, Cast, default_strategy()) .","ref":"wpool.html#cast/2","title":"wpool.cast/2","type":"function"},{"doc":"Picks a server and issues the cast to it","ref":"wpool.html#cast/3","title":"wpool.cast/3","type":"function"},{"doc":"Default strategy","ref":"wpool.html#default_strategy/0","title":"wpool.default_strategy/0","type":"function"},{"doc":"Retrieves the list of worker registered names. This can be useful to manually inspect the workers or do custom work on them.","ref":"wpool.html#get_workers/1","title":"wpool.get_workers/1","type":"function"},{"doc":"Equivalent to send_request(Sup, Call, default_strategy(), 5000) .","ref":"wpool.html#send_request/2","title":"wpool.send_request/2","type":"function"},{"doc":"Equivalent to send_request(Sup, Call, Strategy, 5000) .","ref":"wpool.html#send_request/3","title":"wpool.send_request/3","type":"function"},{"doc":"Picks a server and issues the call to it. Timeout applies only for the time used choosing a worker in the available_worker strategy","ref":"wpool.html#send_request/4","title":"wpool.send_request/4","type":"function"},{"doc":"Starts the application","ref":"wpool.html#start/0","title":"wpool.start/0","type":"function"},{"doc":"Equivalent to start_pool(Name, []) .","ref":"wpool.html#start_pool/1","title":"wpool.start_pool/1","type":"function"},{"doc":"Starts (and links) a pool of N wpool_processes. The result pid belongs to a supervisor (in case you want to add it to a supervisor tree)","ref":"wpool.html#start_pool/2","title":"wpool.start_pool/2","type":"function"},{"doc":"Equivalent to start_sup_pool(Name, []) .","ref":"wpool.html#start_sup_pool/1","title":"wpool.start_sup_pool/1","type":"function"},{"doc":"Starts a pool of N wpool_processes supervised by wpool_sup","ref":"wpool.html#start_sup_pool/2","title":"wpool.start_sup_pool/2","type":"function"},{"doc":"Retrieves a snapshot of the pool stats","ref":"wpool.html#stats/0","title":"wpool.stats/0","type":"function"},{"doc":"Retrieves a snapshot of a given pool stats","ref":"wpool.html#stats/1","title":"wpool.stats/1","type":"function"},{"doc":"Stops the application","ref":"wpool.html#stop/0","title":"wpool.stop/0","type":"function"},{"doc":"Stops the pool","ref":"wpool.html#stop_pool/1","title":"wpool.stop_pool/1","type":"function"},{"doc":"Stops the pool","ref":"wpool.html#stop_sup_pool/1","title":"wpool.stop_sup_pool/1","type":"function"},{"doc":"","ref":"wpool.html#t:custom_strategy/0","title":"wpool.custom_strategy/0","type":"type"},{"doc":"","ref":"wpool.html#t:debug_flag/0","title":"wpool.debug_flag/0","type":"type"},{"doc":"","ref":"wpool.html#t:gen_option/0","title":"wpool.gen_option/0","type":"type"},{"doc":"","ref":"wpool.html#t:gen_options/0","title":"wpool.gen_options/0","type":"type"},{"doc":"","ref":"wpool.html#t:name/0","title":"wpool.name/0","type":"type"},{"doc":"","ref":"wpool.html#t:option/0","title":"wpool.option/0","type":"type"},{"doc":"","ref":"wpool.html#t:stats/0","title":"wpool.stats/0","type":"type"},{"doc":"","ref":"wpool.html#t:strategy/0","title":"wpool.strategy/0","type":"type"},{"doc":"","ref":"wpool.html#t:supervisor_strategy/0","title":"wpool.supervisor_strategy/0","type":"type"},{"doc":"","ref":"wpool.html#t:worker_stats/0","title":"wpool.worker_stats/0","type":"type"},{"doc":"A pool of workers. If you want to put it in your supervisor tree, remember it's a supervisor.","ref":"wpool_pool.html","title":"wpool_pool","type":"module"},{"doc":"Adds a callback module. The module must implement the wpool_process_callbacks behaviour.","ref":"wpool_pool.html#add_callback_module/2","title":"wpool_pool.add_callback_module/2","type":"function"},{"doc":"Picks the worker with the smaller queue of messages.","ref":"wpool_pool.html#best_worker/1","title":"wpool_pool.best_worker/1","type":"function"},{"doc":"Casts a message to all the workers within the given pool.","ref":"wpool_pool.html#broadcast/2","title":"wpool_pool.broadcast/2","type":"function"},{"doc":"Picks the first available worker and sends the call to it. The timeout provided includes the time it takes to get a worker and for it to process the call.","ref":"wpool_pool.html#call_available_worker/3","title":"wpool_pool.call_available_worker/3","type":"function"},{"doc":"Casts a message to the first available worker. Since we can wait forever for a wpool:cast to be delivered but we don't want the caller to be blocked, this function just forwards the cast when it gets the worker","ref":"wpool_pool.html#cast_to_available_worker/2","title":"wpool_pool.cast_to_available_worker/2","type":"function"},{"doc":"Use this function to get the Worker pool record in a custom worker.","ref":"wpool_pool.html#find_wpool/1","title":"wpool_pool.find_wpool/1","type":"function"},{"doc":"Retrieves the list of worker registered names. This can be useful to manually inspect the workers or do custom work on them.","ref":"wpool_pool.html#get_workers/1","title":"wpool_pool.get_workers/1","type":"function"},{"doc":"Picks a worker base on a hash result. phash2 ( Term , Range ) returns hash = integer, 0 &lt;= hash &lt; Range so 1 must be added","ref":"wpool_pool.html#hash_worker/2","title":"wpool_pool.hash_worker/2","type":"function"},{"doc":"Set next within the worker pool record. Useful when using a custom strategy function.","ref":"wpool_pool.html#next/2","title":"wpool_pool.next/2","type":"function"},{"doc":"Picks the first available worker, if any","ref":"wpool_pool.html#next_available_worker/1","title":"wpool_pool.next_available_worker/1","type":"function"},{"doc":"Picks the next worker in a round robin fashion","ref":"wpool_pool.html#next_worker/1","title":"wpool_pool.next_worker/1","type":"function"},{"doc":"Picks a random worker","ref":"wpool_pool.html#random_worker/1","title":"wpool_pool.random_worker/1","type":"function"},{"doc":"Removes a callback module.","ref":"wpool_pool.html#remove_callback_module/2","title":"wpool_pool.remove_callback_module/2","type":"function"},{"doc":"Picks the first available worker and sends the request to it. The timeout provided considers only the time it takes to get a worker","ref":"wpool_pool.html#send_request_available_worker/3","title":"wpool_pool.send_request_available_worker/3","type":"function"},{"doc":"Starts a supervisor with several wpool_process es as its children","ref":"wpool_pool.html#start_link/2","title":"wpool_pool.start_link/2","type":"function"},{"doc":"Retrieves the pool stats for all pools","ref":"wpool_pool.html#stats/0","title":"wpool_pool.stats/0","type":"function"},{"doc":"Retrieves a snapshot of the pool stats","ref":"wpool_pool.html#stats/1","title":"wpool_pool.stats/1","type":"function"},{"doc":"","ref":"wpool_pool.html#worker_name/2","title":"wpool_pool.worker_name/2","type":"function"},{"doc":"Get values from the worker pool record. Useful when using a custom strategy function.","ref":"wpool_pool.html#wpool_get/2","title":"wpool_pool.wpool_get/2","type":"function"},{"doc":"","ref":"wpool_pool.html#t:wpool/0","title":"wpool_pool.wpool/0","type":"opaque"},{"doc":"Decorator over gen_server that lets wpool_pool control certain aspects of the execution","ref":"wpool_process.html","title":"wpool_process","type":"module"},{"doc":"Equivalent to gen_server:call(Process, Call, Timeout) .","ref":"wpool_process.html#call/3","title":"wpool_process.call/3","type":"function"},{"doc":"Equivalent to gen_server:cast(Process, {cast, Cast}) .","ref":"wpool_process.html#cast/2","title":"wpool_process.cast/2","type":"function"},{"doc":"Equivalent to gen_server:send_request(Process, Request) .","ref":"wpool_process.html#send_request/2","title":"wpool_process.send_request/2","type":"function"},{"doc":"Starts a named process","ref":"wpool_process.html#start_link/4","title":"wpool_process.start_link/4","type":"function"},{"doc":"","ref":"wpool_process.html#t:from/0","title":"wpool_process.from/0","type":"type"},{"doc":"","ref":"wpool_process.html#t:next_step/0","title":"wpool_process.next_step/0","type":"type"},{"doc":"","ref":"wpool_process.html#t:options/0","title":"wpool_process.options/0","type":"type"},{"doc":"","ref":"wpool_process.html#t:state/0","title":"wpool_process.state/0","type":"opaque"},{"doc":"","ref":"wpool_process_callbacks.html","title":"wpool_process_callbacks","type":"behaviour"},{"doc":"Adds a callback module.","ref":"wpool_process_callbacks.html#add_callback_module/2","title":"wpool_process_callbacks.add_callback_module/2","type":"function"},{"doc":"","ref":"wpool_process_callbacks.html#c:handle_init_start/1","title":"wpool_process_callbacks.handle_init_start/1","type":"callback"},{"doc":"","ref":"wpool_process_callbacks.html#c:handle_worker_creation/1","title":"wpool_process_callbacks.handle_worker_creation/1","type":"callback"},{"doc":"","ref":"wpool_process_callbacks.html#c:handle_worker_death/2","title":"wpool_process_callbacks.handle_worker_death/2","type":"callback"},{"doc":"Sends a notification to all registered callback modules.","ref":"wpool_process_callbacks.html#notify/3","title":"wpool_process_callbacks.notify/3","type":"function"},{"doc":"Removes a callback module.","ref":"wpool_process_callbacks.html#remove_callback_module/2","title":"wpool_process_callbacks.remove_callback_module/2","type":"function"},{"doc":"","ref":"wpool_process_callbacks.html#t:event/0","title":"wpool_process_callbacks.event/0","type":"type"},{"doc":"","ref":"wpool_process_callbacks.html#t:state/0","title":"wpool_process_callbacks.state/0","type":"type"},{"doc":"Common functions for wpool_process and other modules.","ref":"wpool_utils.html","title":"wpool_utils","type":"module"},{"doc":"Adds default parameters to a pool configuration","ref":"wpool_utils.html#add_defaults/1","title":"wpool_utils.add_defaults/1","type":"function"},{"doc":"Removes the current task from the worker","ref":"wpool_utils.html#task_end/1","title":"wpool_utils.task_end/1","type":"function"},{"doc":"Marks Task as started in this worker","ref":"wpool_utils.html#task_init/2","title":"wpool_utils.task_init/2","type":"function"},{"doc":"Default instance for wpool_process","ref":"wpool_worker.html","title":"wpool_worker","type":"module"},{"doc":"Returns the result of M:F(A) from any of the workers of the pool S","ref":"wpool_worker.html#call/4","title":"wpool_worker.call/4","type":"function"},{"doc":"Executes M:F(A) in any of the workers of the pool S","ref":"wpool_worker.html#cast/4","title":"wpool_worker.cast/4","type":"function"},{"doc":"","ref":"wpool_worker.html#t:from/0","title":"wpool_worker.from/0","type":"type"},{"doc":"","ref":"wpool_worker.html#t:state/0","title":"wpool_worker.state/0","type":"opaque"},{"doc":"A pool of gen servers.","ref":"readme.html","title":"Worker Pool","type":"extras"},{"doc":"The goal of worker pool is pretty straightforward: To provide a transparent way to manage a pool of workers and do the best effort in balancing the load among them distributing the tasks requested to the pool.","ref":"readme.html#abstract","title":"Worker Pool - Abstract","type":"extras"},{"doc":"The documentation can be generated from code using rebar3_ex_doc with rebar3 ex_doc . It is also available online here","ref":"readme.html#documentation","title":"Worker Pool - Documentation","type":"extras"},{"doc":"All user functions are exposed through the wpool module . Starting the Application Worker Pool is an erlang application that can be started using the functions in the application module. For convenience, wpool:start/0 and wpool:stop/0 are also provided. Starting a Pool To start a new worker pool, you can either use wpool:start_pool (if you want to supervise it yourself) or wpool:start_sup_pool (if you want the pool to live under wpool's supervision tree). You can provide several options on any of those calls: overrun_warning : The number of milliseconds after which a task is considered overrun (i.e. delayed) so a warning is emitted using overrun_handler . The task is monitored until it is finished, thus more than one warning might be emitted for a single task. The rounds of warnings are not equally timed, an exponential backoff algorithm is used instead: after each warning the overrun time is doubled (i.e. with overrun_warning = 1000 warnings would be emitted after 1000, 2000, 4000, 8000 ...) The default value for this setting is infinity (i.e. no warnings are emitted) max_overrun_warnings : The maximum number of overrun warnings emitted before killing a delayed task: that is, killing the worker running the task. If this parameter is set to a value other than infinity the rounds of warnings becomes equally timed (i.e. with overrun_warning = 1000 and max_overrun_warnings = 5 the task would be killed after 5 seconds of execution) The default value for this setting is infinity (i.e. delayed tasks are not killed) NOTE: As the worker is being killed it might cause worker's messages to be missing if you are using a worker stategy other than available_worker (see worker strategies below) overrun_handler : The module and function to call when a task is overrun . The default value for this setting is {error_logger, warning_report} . Repor values are: {alert, AlertType} : Where AlertType is overrun on regular warnings, or max_overrun_limit when the worker is about to be killed. {pool, Pool} : The poolname {worker, Pid} : Pid of the worker {task, Task} : A description of the task {runtime, Runtime} : The runtime of the current round workers : The number of workers in the pool. The default value for this setting is 100 worker_type : The type of the worker. The available values are gen_server . The default value is gen_server . Eventually we'll add gen_statem as well. worker : The gen_server module that each worker will run and the InitArgs to use on the corresponding start_link call used to initiate it. The default value for this setting is {wpool_worker, undefined} . That means that if you don't provide a worker implementation, the pool will be generated with this default one. wpool_worker is a module that implements a very simple RPC-like interface. worker_opt : Options that will be passed to each gen_server worker. This are the same as described at gen_server documentation. worker_shutdown : The shutdown option to be used in the child specs of the workers. Defaults to 5000 . strategy : Not the worker selection strategy (discussed below) but the supervisor flags to be used in the supervisor over the individual workers ( wpool_process_sup ). Defaults to {one_for_one, 5, 60} pool_sup_intensity and pool_sup_period : The intensity and period for the supervisor that manages the worker pool system ( wpool_pool ). The strategy of this supervisor must be one_for_all but the intensity and period may be changed from their defaults of 5 and 60 . pool_sup_shutdown : The shutdown option to be used for the supervisor over the individual workers ( wpool_process_sup ). That is, the value set in the child spec for this supervisor, which is specified in its parent supervisor ( wpool_pool ). queue_type : Order in which requests will be stored and handled by workers. This option can take values lifo or fifo . Defaults to fifo . enable_callbacks : A boolean value determining if event_manager should be started for callback modules. Defaults to false . callbacks : Initial list of callback modules implementing wpool_process_callbacks to be called on certain worker events. This options will only work if the enable_callbacks is set to true . Callbacks can be added and removed later by wpool_pool:add_callback_module/2 and wpool_pool:remove_callback_module/2 . Using the Workers Since the workers are gen_server s, messages can be call ed or cast ed to them. To do that you can use wpool:call and wpool:cast as you would use the equivalent functions on gen_server . Choosing a Strategy Beyond the regular parameters for gen_server , wpool also provides an extra optional parameter: Strategy . The strategy used to pick up the worker to perform the task. If not provided, the result of wpool:default_strategy/0 is used. The available strategies are defined in the wpool:strategy() type and also described below: best_worker Picks the worker with the smaller queue of messages. Loosely based on this article . This strategy is usually useful when your workers always perform the same task, or tasks with expectedly similar runtimes. random_worker Just picks a random worker. This strategy is the fastest one when to select a worker. It's ideal if your workers will perform many short tasks. next_worker Picks the next worker in a round-robin fashion. That ensures evenly distribution of tasks. available_worker Instead of just picking one of the workers in the queue and sending the request to it, this strategy queues the request and waits until a worker is available to perform it. That may render the worker selection part of the process much slower (thus generating the need for an additional parameter: Worker_Timeout that controls how many milliseconds is the client willing to spend in that, regardless of the global Timeout for the call). This strategy ensures that, if a worker crashes, no messages are lost in its message queue. It also ensures that, if a task takes too long, that doesn't block other tasks since, as soon as other worker is free it can pick up the next task in the list. next_available_worker In a way, this strategy behaves like available_worker in the sense that it will pick the first worker that it can find which is not running any task at the moment, but the difference is that it will fail if all workers are busy. hash_worker This strategy takes a key and selects a worker using erlang:phash2/2 . This ensures that tasks classified under the same key will be delivered to the same worker, which is useful to classify events by key and work on them sequentially on the worker, distributing different keys across different workers. Broadcasting a Pool Wpool provides a way to broadcast a message to every worker within the given Pool. 1 &gt; wpool : start ( ) . ok 2 &gt; wpool : start_pool ( my_pool , [ { workers , 3 } ] ) . { ok , &lt; 0.299 . 0 &gt; } 3 &gt; wpool : broadcast ( my_pool , { io , format , [ &quot;I got a message. ~n &quot; ] } ) . I got a message . I got a message . I got a message . ok NOTE: This messages don't get queued, they go straight to the worker's message queues, so if you're using available_worker strategy to balance the charge and you have some tasks queued up waiting for the next available worker, the broadcast will reach all the workers before the queued up tasks. Watching a Pool Wpool provides a way to get live statistics about a pool. To do that, you can use wpool:stats/1 . Stopping a Pool To stop a pool, just use wpool:stop_pool/1 .","ref":"readme.html#usage","title":"Worker Pool - Usage","type":"extras"},{"doc":"To see how wpool is used you can check the test folder where you'll find many different scenarios exercised in the different suites. If you want to see worker_pool in a real life project, I recommend you to check sumo_db , another open-source library from Inaka that uses wpool intensively.","ref":"readme.html#examples","title":"Worker Pool - Examples","type":"extras"},{"doc":"wpool comes with a very basic benchmarker that let's you compare different strategies against the default wpool_worker . If you want to do the same in your project, you can use wpool_bench as a template and replace the worker and the tasks by your own ones.","ref":"readme.html#benchmarks","title":"Worker Pool - Benchmarks","type":"extras"},{"doc":"If you find any bugs or have a problem while using this library, please open an issue in this repo (or a pull request :)).","ref":"readme.html#contact-us","title":"Worker Pool - Contact Us","type":"extras"},{"doc":"Worker Pool is available on Hex.pm .","ref":"readme.html#on-hex-pm","title":"Worker Pool - On Hex.pm","type":"extras"},{"doc":"Required OTP version 25 or higher. We only provide guarantees that the system runs on OTP25+ since that's what we're testing it in, but the minimum_otp_vsn is &quot;21&quot; because some systems where worker_pool is integrated do require it.","ref":"readme.html#requirements","title":"Worker Pool - Requirements","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 https://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright 2022 Inaka, Brujo Benavides Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at https://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"}]